{ Unit:            mystack.pas
  Autor:           Sascha Nemecek
  Matrikelnr.:     9825815
  Erstellt am:     10.04.1999
  Letzte nderung: 19.04.1999

  Kurzbeschreibung:
  Realisierung eines einfachen Stacks (LIFO-Speicher) der es ermglicht
  beliebige Zeiger zu Speichern und wieder zu laden. Dafr stehen
  folgende Methoden zu Verfgung:

     push    - Mit dieser Methode wird ein Element (Pointer) als oberstes
               abgelegt.
     pop     - Mit dieser Methode wird das oberste Element des Stacks
               ausgelesen. Ist der Stack leer wird NIL zurckgegeben.
     isEmpty - Gibt TRUE zurck wenn der Stack leer ist.
  }


UNIT mystack;


INTERFACE

TYPE


{ Definition eines Stackknotens. }
stackKnotenPtr = ^stackKnoten;
stackKnoten = RECORD
   inhalt: pointer;
   next: stackKnotenPtr;
END;


{ Initialisierung der Klasse Stack. }
stackPtr = ^stack;
stack = OBJECT
   CONSTRUCTOR Init;
   PROCEDURE push (p: pointer);
   FUNCTION pop : pointer;
   FUNCTION isEmpty : boolean;
   DESTRUCTOR Done;

  PRIVATE
   top: stackKnotenPtr;
END;



IMPLEMENTATION



{ Constructor Init.
  Setzt alle Anfangswerte. }
CONSTRUCTOR stack.Init;
BEGIN
   top := NIL;
END;



{ Prozedur push.
  Fgt ein neues Element in den Stack ein.
  @param p Pointer der Eingefgt werden soll. }
PROCEDURE stack.push (p: pointer);
VAR h: stackKnotenPtr;
BEGIN
   new (h);
   h^.next := top;
   top := h;
   h^.inhalt := p;
END;



{ Funktion pop.
  Liet das oberste Element aus dem Stack aus.
  @return Pointer, der zurckgegeben wird. }
FUNCTION stack.pop : pointer;
VAR h1: stackKnotenPtr;
    h2: pointer;
BEGIN
   IF top = NIL THEN
      pop := NIL;
   h1 := top;
   h2 := top^.inhalt;
   top := top^.next;
   dispose (h1);
   pop := h2;
END;



{ Funktion isEmpty.
  berprft ob der Stack leer ist. Wenn ja liefert sie TRUE zurck.
  @return TRUE, wenn der Stack leer ist. }
FUNCTION stack.isEmpty : boolean;
BEGIN
   IF top <> NIL THEN
      isEmpty := FALSE
   ELSE
      isEmpty := TRUE;
END;



{ DESTRUCTOR Done.
  Lscht alle Elemente im Stack. }
DESTRUCTOR stack.Done;
VAR dummy: pointer;
BEGIN
   WHILE isEmpty = FALSE do
      dummy := pop;
END;


BEGIN
END.